package org.expeditee.network;

import java.io.IOException;
import java.net.DatagramSocket;

public abstract class DefaultServer extends Thread {


	protected static final int MAX_PACKET_LENGTH = 64000;
	protected static final int FRAMENAME_PACKET_LENGTH = 1000;
	
	protected boolean _stop = false;
	protected DatagramSocket socket = null;

	public DefaultServer() {
		super();
	}

	public DefaultServer(Runnable target) {
		super(target);
	}
	
	protected DefaultServer(String name) {
		super(name);
	}

	public DefaultServer(String name, int port) throws IOException {
		super(name);
		socket = new DatagramSocket(port);
	}

	public DefaultServer(ThreadGroup group, Runnable target) {
		super(group, target);
	}

	public DefaultServer(ThreadGroup group, String name) {
		super(group, name);
	}

	public DefaultServer(Runnable target, String name) {
		super(target, name);
	}

	public DefaultServer(ThreadGroup group, Runnable target, String name) {
		super(group, target, name);
	}

	public DefaultServer(ThreadGroup group, Runnable target, String name,
			long stackSize) {
		super(group, target, name, stackSize);
	}

	public void close() {
		_stop = true;
	}

	public void run() {
		//MessageBay.displayMessage(this.getName() + " started on port "
		//		+ socket.getLocalPort());

		while (!_stop) {
			try {
				listenForMessages();
	
			} catch (IOException e) {
				e.printStackTrace();
			}
		}
		socket.close();
	}

	protected abstract void listenForMessages() throws IOException;

}